
#ifndef FVEC_H_
#define FVEC_H_


// Might have copied this code from somewhere, but don't remember.

struct Fvec {
    int rows;
    int cols;
    float ** table;
};


Fvec * init_Fvec(int rows, int cols, float init_val) {
    Fvec * fvec = (Fvec*) safemalloc(sizeof(Fvec));
    fvec->rows=rows;
    fvec->cols=cols;
    fvec->table = (float**) safemalloc(sizeof(float*)*fvec->rows);

    for(int row_i = 0; row_i < fvec->rows; row_i++) {
        fvec->table[row_i] = (float*) safemalloc(sizeof(float)*fvec->cols);
        for(int col_i = 0; col_i < fvec->cols; col_i++) {
            fvec->table[row_i][col_i] = init_val;
        }
    }
    return fvec;
}

int write_fvec(const std::string &path, Fvec * fvec ) {

    // first 4 bytes(float): length of vector (K+1)
    // next D*4 bytes(float):

    const char * fname = path.c_str();
    FILE *fp;
    fp = fopen(fname,"w");
    if(!fp) {
        terminal_error("Cannot open file\n");
    }

    for(int row_i = 0; row_i < fvec->rows; row_i++) {
        fwrite((char*)(&fvec->cols),1,sizeof(int),fp);
        for(int col_i = 0; col_i < fvec->cols; col_i++) {
            fwrite((char*)(&fvec->table[row_i][col_i]),1,sizeof(float),fp);
        }
    }
    fclose(fp);
}

#endif


